import object        
        
#
# This example show how a class can add an alternate constructor to
# a class.
#

class eggs(object.base):
    def __init__(self, a):
	self.a = a
	self.b = 0

    def __repr__(self):
	return repr(self.__dict__)
    
    class __class__:

	#
	# This is the default version of the call operator.  It is
	# used for constructing both classes as instances so it is is
	# bit more general than is necessary for this application.  it
	# is include here only to show what is really going on.
	#
        def __call__(self, *args, **kw):
            i = apply(self.__new__, args, kw)
            try:
                init = i.__init__
            except AttributeError:
                pass
            else:
                if kw:
                    apply(init, args, kw)
                else:
                    apply(init, args)
            return i
	    

	#
	# Since this_way "knows" that it is going to be constructing
	# an instance of a class, things get a bit simpler.  First, an
	# uninitialized instance of the class is created by calling
	# default __new__ method.  Next the instance is initialize by
	# calling its __init__ method.  Finally, the arguments to the
	# constructor are applied to the instance.  Note that whether
	# the instance's __init__ method gets called is the
	# responsibility of the meta-class.... it doesn't have to
	# happen.
	# 
        def this_way(self, b):
            i = self.__new__()
	    i.__init__(10)
	    i.b = b
	    return i
	    
	#
	# Here is another way of creating an instance.  Effectively,
	# it it is the same at the previous one.  The class calls
	# itself to create an initialized instance (note that __init__
	# does get called in this case) and then applies the arguments
	# passed to it.
	#
	def that_way(self, b):
	    i = self(10)
	    i.b = b
	    return i

#
# Care must be taken when alternate constructors are used with classes
# that are intended to be sub-classed.  When the alternate constructor
# calls the __init__ method of the instance of a sub-class, it doesn't
# really know what arguments are expected.  To use this technique
# effectively, some policy must be implemented for the initialization
# of sub-class instances through a method with a known parameter list.
# This will likely require some work to the __call__ method of class
# as well.
#	    


i0 = eggs(1)
i1 = eggs.this_way(5)
i2 = eggs.that_way(12)

print i0, i1, i2
